<?php
/*Controller Code for Displaying the Results of the Math Facts Tool*/

/*
	Use gto(Subheading, IntVariable, TestVariable) for Testing
	Call with the Get Method - ?debug=IntVariable
	Use Subheading to identify contents of TestVariable
*/

	session_start();
	
	include_once $_SERVER['DOCUMENT_ROOT'] . '/includes/magicquotes.inc.php';
	include_once $_SERVER['DOCUMENT_ROOT'] . '/includes/helpers.inc.php';
	include_once $_SERVER['DOCUMENT_ROOT'] . '/includes/access.inc.php';

if (!userisloggedin())
{
	$_SESSION['loginerror'] = "You must log in to view your progress page.";
  header('Location: ../');
  exit(); 
}

//If wrong answer is to be displayed, do that now and return to display.
//Otherwise, insure that wrong answer server variables are reset.

		if (isset($_GET['wronganswer']))
			{
							$testresults = "string_get wronganswer is apparently set.";

				include $_SERVER['DOCUMENT_ROOT'] . '/includes/mfdb.inc.php';
				$sql = "select * from inc_answers where session_id = " . $_GET['wronganswer'];
				
							$testresults .= "<br />Sql text to select incorrect answers is:";
							$testresults .= $sql;
				
				$result = mysqli_query($link, $sql);
				if(!$result)
				{
					$error = 'Error obtaining wrong answers from database.';
					include $_SERVER['DOCUMENT_ROOT'] . '/includes/error.html.php';
					exit();
				}
			
				while ($row = mysqli_fetch_array($result))
				{
					$wronganswers[] = array
					(
						'sess_id' => $row['session_id'],
						'problem' => $row['problem'],
						'answer' => $row['answer']
					);
				}	
			}
			else
			{
				unset($_SESSION['wrngsess']);
			}

// $_GET['wronganswer']) is not set. Get preliminary display results data

// But if session_id is not set, just skip this section to display all results
//
if ($_SESSION['PracticeCompleted']=='True' and isset($_SESSION['session_id']))
{
		include $_SERVER['DOCUMENT_ROOT'] . '/includes/mfdb.inc.php';
		
		$firstname = get_scalar('select first_name from members where id = ' . $_SESSION['student_id']);
				
		$sql = "select count(*) \n"
    . "from recent_results_vw \n"
    . "where time=0 and session_id = " . $_SESSION['session_id'];
    
		$numbermissed = get_scalar($sql);
		$numberproblems = sizeof($_SESSION['families']);
		//gto('Number problems',$numberproblems);
		if ($numberproblems==0)		//Notify user if no practice sessions are found.
		{
			$_SESSION['loginerror'] = "You do not have any results to view.";
		  header('Location: ../');
		  exit(); 
		}
		$score = round(($numberproblems-$numbermissed)/$numberproblems,2)*100;
		

//Configure message text to user
				$msg = "<center><h1>Total Score $score Percent.</h1></center><br />";
	if ($score==100)
		{
				$msg .= "<h2>Very well done, $firstname!</h2><br>";
				$msg .= "From a total of $numberproblems,	problems, you did not miss a single one!"; 
		}
	elseif ($score>90)
		{
				$msg .= "<h2>Good job, $firstname!</h2><br>";
				$msg .= "From a total of $numberproblems problems, you only missed $numbermissed."; 
		}
	elseif ($score>80)
		{
				$msg .= "<h2>Keep up the good work, $firstname!</h2><br>";
				$msg .= "From a total of $numberproblems,	problems, you missed $numbermissed."; 
		}
	else
		{
				$msg .= "<h2>Keep working, $firstname. <br /> Remember, practice makes perfect.</h2>";
		}
}	

//Insure that user has completed at least one practice session
	if ($numberproblems=="")
	{
		$sql = "select count(1) from student_summary_vw where st_id = \n"
			 . $_SESSION['student_id'];
		$numberproblems = get_scalar($sql);
	}
	//gto('Query text:',$sql);
	//gto('Number sessions is:',$numberproblems);	
	if ($numberproblems==0 || $numberproblems=="")		//Notify user if no practice sessions are found.
		{
			$_SESSION['loginerror'] = "You do not have any results to view.";
		  header('Location: ../');
		  exit(); 
		}

//Fill array with user's results
		$sql = "SELECT * \n"
    . "FROM student_summary_vw \n"
    . "WHERE st_id = " . $_SESSION['student_id'] . "\n"
    . "order by sess_id desc \n"
    . "limit 50";

	$testresults .= $sql;
    include $_SERVER['DOCUMENT_ROOT'] . '/includes/mfdb.inc.php';
		$result = mysqli_query($link, $sql);
			if(!$result)
			{
				$error = 'Error obtaining student results from database.';
				include $_SERVER['DOCUMENT_ROOT'] . '/includes/error.html.php';
				exit();
			}
			
			while ($row = mysqli_fetch_array($result))
			{
				$rslts[] = array(
					'st_id' => $row['st_id'],
					'sess_id' => $row['sess_id'],
					/*'date' => $row['date'], Changed to next line - 11/2/09*/
					'date' => date('M j g:i a', strtotime($row['date'])),
					'name' => $row['name'],
					'type' => $row['type'],
					'problems' => $row['problems'],
					'range' => $row['range'],
					'correct' => $row['right'],
					'wrong' => $row['wrong'],
					'avg_time' => $row['avg_time'],		/*Modified 11/02/2009 to include underscores*/
					'< 5 secs' => $row['<_5_secs'],
					'< 3 secs' => $row['<_3_secs']
					);
			}	
		
		$testresults .= "<br />Number records in rslts array is " . sizeof($rslts) . ".<br />";

/*
//----------Test Block to display value of variables to this point-----------//
	$error = print_r($_SESSION,true);																										 //
	//$error = print_r($_GET,true);
	include $_SERVER['DOCUMENT_ROOT'] . '/includes/error.html.php';						 //
	exit();																																		 //
//---------------------------------------------------------------------------//			
*/

 		include 'display.html.php';
 		//session_destroy();
		exit();
		
	
?>