<?php //Controller script for Practice


/*
	Use gto(Subheading, TestVariable, IntVariable) for Testing
	Call with the Get Method - ?debug=IntVariable
	Use Subheading to identify contents of TestVariable
*/

$testing = "";

include_once $_SERVER['DOCUMENT_ROOT'] . '/includes/magicquotes.inc.php';
include_once $_SERVER['DOCUMENT_ROOT'] . '/includes/helpers.inc.php';
include_once $_SERVER['DOCUMENT_ROOT'] . '/includes/access.inc.php';

session_start();
if (!userisloggedin())
{
	/*include '../';
	exit();	*/
	$_SESSION['loginerror'] = "You must log in to view the practice page.";
  //gto('Practice index - Session variable:',$_SESSION);
  header('Location: ../');
  
  exit(); 
}

//Check if operation has not been selected
if (!$_SESSION['operator'])
{
	$_SESSION['loginerror'] = "Please select a fact type before practicing problems.";
	header('Location: ../');
	exit();
}

//Reset variable indicating practice session completion.
	unset($_SESSION['PracticeCompleted']);

//Process answer response
if (isset($_REQUEST['answer']))
	{
	//Process returned answer
		$given_answer = htmlspecialchars($_REQUEST['answer'], ENT_QUOTES, 'UTF-8');
		$given_answer = str_replace(" ","",$given_answer);
		$given_answer += 0;		
		if (!is_int($given_answer))
			$given_answer = 0;

	//Get elapsed time
		if ($_SESSION['start_time'])
		{
			$elapsed_time = number_format(gettimeofday(true)-$_SESSION['start_time'],2);
			$_SESSION['start_time'] = gettimeofday(true);		//reset variable for next problem
		}
		else
		{
			$elapsed_time = "NA";
		}
		
	//Set other variables
			$student_id = $_SESSION['student_id'];
			$ff_id = $_SESSION['families'][$_SESSION['arr_pos']]['id'];
			$operation = $_SESSION['operator'];
			$session_id = $_SESSION['session_id'];
			$fnum = $_SESSION['families'][$_SESSION['arr_pos']]['fnum'];
			$snum = $_SESSION['families'][$_SESSION['arr_pos']]['snum'];
			$op = $_SESSION['op_symbol'];
		
	//Check given answer. If answer is correct, leave time inserted above.
	//If answer is incorrect, insert 0.
			//$given_answer = str_replace(" ","",$_REQUEST['answer']);																	//eliminate spaces in given answer
			$db_answer = str_replace(" ","",$_SESSION['families'][$_SESSION['arr_pos']]['answer']);		//and in answer stored in db
			if ($given_answer != $db_answer)
				{
					$elapsed_time = 0;	//else elapsed time remains what it was set to above
					$_SESSION['inc_answers'] .= "('$session_id','$fnum $op $snum = $db_answer','$given_answer'),";
					$_SESSION['inc_answers'] = str_replace("  "," ",$_SESSION['inc_answers']);
				}
			
		$_SESSION['insertvals'] .= "('". date('YmdHis') . "', '$session_id','$student_id','$ff_id','$operation','$elapsed_time'),";
		
	//Increment pointer value
			if ($_SESSION['arr_pos'] < sizeof($_SESSION['families'])-1)
				$_SESSION['arr_pos'] += 1; 
			else
				{
				//session_destroy();
				//Finish insert statement into student_results table
					$sql = "insert into student_results (date, session_id, student_id, fact_family_id, operation, elapsed_time) values ";
					$sql .= rtrim($_SESSION['insertvals'],",") . ";";
				
				//Attempt to insert all answer values into student_results
				include $_SERVER['DOCUMENT_ROOT'] . '/includes/mfdb.inc.php';	
				if (!mysqli_query($link, $sql))
					{
						$error = 'Error adding answer to student_results.';
						include 'error.html.php';
						exit();
					}
				unset($_SESSION['insertvals']);
				
				//Attempt to insert values of wrong answers into inc_answers
				//First show that session was completed
					$_SESSION['PracticeCompleted']='True';
					if (count($_SESSION['inc_answers']) > 0)
					{
						$sql = "insert into inc_answers (session_id, problem, answer) values ";
						$sql .= rtrim($_SESSION['inc_answers'],",") . ";";
						if (!mysqli_query($link, $sql))
						{
							$error = 'Error adding incorrect answers to database.';
							include 'error.html.php';
							exit();
						}
					}
				unset($_SESSION['inc_answers']);
				
				//Display results of sessions for this user
					header('Location: ../display_results');
					exit();
				}
				
		//Post problem to student
			include 'equation.html.php';
			unset($_SESSION['temp']);
			exit();
	}	//Process answer response
	

//Setup Session variables
	unset($_SESSION['insertvals']);
	include $_SERVER['DOCUMENT_ROOT'] . '/includes/mfdb.inc.php';
	
	//Insure that operation and student_id were set on config page.
		if (!$_SESSION['operator'] || !$_SESSION['student_id'])
			{
				/*$error = 'Initial variables not set. You must use configuration page.';
   			include $_SERVER['DOCUMENT_ROOT'] . '/includes/error.html.php';*/
   			$_SESSION['loginerror'] = "You must log in to view this page.";
   			header('Location: ../');
   			exit(); 
   		}
		else
			$operator = $_SESSION['operator'];
			//student id set to variable later
				
	$testresults .= "Operator is $operator.<br />";
	
	//Next line removed on April 4, 2013 because of errors
	gto("Operator",$testresults,1);
		
	//Set operator symbol
		if ($operator=="Add")
			$op_symbol = "+";
		elseif ($operator=="Subtract")
			$op_symbol = "-";
		elseif ($operator=="Multiply")
			$op_symbol = "x";
		else
			$op_symbol = "&divide;";		//ascii code 0247 is regular division symbol
	
	$testresults .= "Operation symbol is $op_symbol.<br />";
	
	//Query database for relevant fact families	
		//Get number ranges
		$sql = "select max_number from student_config \n"
		. "where student_id = " . $_SESSION['student_id']
		. " and operation = '" . $_SESSION['operator'] . "'";
		$maxnumber = get_scalar($sql);
		
		//If max_number not found, this person does not have right to use this operator.
		if (!$maxnumber)
			{
				$error = "You have not been setup to practice "
							. "problems of this type (" . $_SESSION['operator'] . ").";
				include $_SERVER['DOCUMENT_ROOT'] . '/includes/error.html.php';
	   		exit();
	   	}
		$testresults .= "Max number is $maxnumber. <br />";
		
		$sql = "select min_number from student_config \n"
		. "where student_id = " . $_SESSION['student_id']
		. " and operation = '" . $_SESSION['operator'] . "'";
		$minnumber = get_scalar($sql);
		
		$testresults .= "Min number is $minnumber. <br />";
		
		$sql = "select number_problems from student_config \n"
		. "where student_id = " . $_SESSION['student_id']
		. " and operation = '" . $_SESSION['operator'] . "'";
		$numberproblems = get_scalar($sql);
		if ($numberproblems==0)
			$numberproblems = 200;
		
		$testresults .= "Number of problems is $numberproblems. <br />";
		gto("Line 160",$testresults,2);
		$student_id = $_SESSION['student_id'];
		

/*	Previous code
		$sql = "SELECT id, first_number, second_number, third_number \n"
    . "FROM fact_family \n"
    . "WHERE operation like '%$operator%' and \n"
    . "first_number<=$maxnumber and \n"
    . "second_number<=$maxnumber and \n"
    . "first_number>=$minnumber and \n"
    . "second_number>=$minnumber"; 
*/
		//New Code attempt
		$sql = "SELECT id, first_number, second_number, third_number \n"
			 . "FROM fact_family \n"
			 . "WHERE operation like '%$operator%' and \n"
			 . "first_number<=$maxnumber and \n"
			 . "second_number<=$maxnumber and \n"
			 . "first_number>=$minnumber and \n"
			 . "second_number>=$minnumber and \n"
			 . "id not in \n"
			 . "(select ff_id from \n"
			 . "(select \n"
			 . "sr.fact_family_id as ff_id, \n"
			 . "sum(if(sr.elapsed_time=0,0,1)) as numb_probs, \n"
			 . "avg(nullif(sr.elapsed_time,0)) as time, \n"
			 . "sc.proficiency_time_limit as prof_time, \n"
			 . "sc.proficiency_iterations as prof_iter \n"
			 . "from \n"
			 . "student_results as sr \n"
			 . "inner join student_config as sc \n"
			 . "on \n"
			 . "sr.student_id = sc.student_id and \n"
			 . "sr.operation = sc.operation \n"
			 . "where \n"
			 . "sr.student_id = $student_id and \n"
			 . "sr.operation = '$operator' \n"
			 . "group by \n"
			 . "ff_id \n"
			 . "having \n"
			 . "numb_probs >= prof_iter and \n"
			 . "time <= prof_time) as t2 \n"
			 . ")";
  
  	$testresults .= "SQL text has been set.<br />";
  	$testresults .= "Text of sql statment is: <br />" . $sql . "<br />";

 	
  $result = mysqli_query($link, $sql);
  
	   if (!$result)
	   {
	   $error = 'Error adding fact families.';
	   include $_SERVER['DOCUMENT_ROOT'] . '/includes/error.html.php';
	   exit();	
	   }
	
	$testresults .= "Query executed successfully.<br />";
	
	
	
	//Add resultset to array  
		while ($row = mysqli_fetch_array($result))
		if ($operator=="Add" || $operator=="Multiply")
			{
				$families[] = array('id' => $row['id'], 
														'fnum' => $row['first_number'], 
														'snum' => $row['second_number'], 
														'answer' => $row['third_number']);
				
				If ($row['first_number']!=$row['second_number'])
					{$families[] = array('id' => $row['id'],
															 'fnum' => $row['second_number'],
															 'snum' => $row['first_number'],
															 'answer' => $row['third_number']);
					}
															
			}
		else	//Subtract or Divide
			{
				//Exclude rows where operator is divide and divisor is 0
				if (!($operator=="Divide" and $row['first_number']==0))
				{
					$families[] = array('id' => $row['id'],
															'fnum' => $row['third_number'],
															'snum' => $row['first_number'],
															'answer' => $row['second_number']);
				}
				if (!($operator=="Divide" and $row['second_number']==0))
				{
					If ($row['first_number']!=$row['second_number'])
						$families[] = array('id' => $row['id'],
																'fnum' => $row['third_number'],
																'snum' => $row['second_number'],
																'answer' => $row['first_number']);
				}
			}
  
  //gto('size of initial array',sizeof($families));
  
  if(sizeof($families)==0)
  {
  	$op = $_SESSION['operator'];
  	$tmp = "You have learned all fact families for $op"."ing. <br />";
  	$tmp .= "Ask your teacher to extend your fact families <br>for $op"."ing ";
  	$tmp .= "or add additional problem types.";
  	$_SESSION['loginerror'] = $tmp;
    header('Location: ../');
  	exit(); 
  }
  
  $testresults .= "Resulting array initially has " . sizeof($families) . " rows. <br />";
  	
	//Shuffle array
		shuffle($families);
		
	$testresults .= "Original text of the families array: <br />";
	$testresults .= print_r($families,true) . "<br />";


	//Reduce size of array to $numberproblems
		if (sizeof($families)>$numberproblems)
		{
			$families = array_slice($families,0,$numberproblems,true);
		}

	$testresults .= "Reduced array has " . sizeof($families) . "rows. <br />";
	$testresults .= print_r($families,true) . "<br />";
		
	//Add array to session variable
		$_SESSION['families'] = $families;
		
	//Initialize session vars to hold pointer value and operator
		$_SESSION['arr_pos'] = 0;
		$_SESSION['op_symbol'] = $op_symbol;
		//$_SESSION['operator'] = $operator;
		$_SESSION['start_time'] = gettimeofday(true);
		$_SESSION['sess_st_time'] = gettimeofday(true);
		
	//Set session_id
	//This was done initially by selecting max(session_id) from student_results and adding one to it
	// That resulted in duplicate session_ids in student_results
	// student_session was added to eliminate this problem (09/21/2009)
			$sql = "insert into student_session (student_id) values (" . $_SESSION['student_id'] . ")";
			
			$testresults .= "sql to insert student_id into student_session table is: <br>";
			$testresults .= $sql;

/*	
//----------Test Block to display value of variables to this point-----------//
	//$testresults = $sql;
	$error = $testresults;																										 //
	include $_SERVER['DOCUMENT_ROOT'] . '/includes/error.html.php';						 //
	exit();																																		 //
//---------------------------------------------------------------------------//	  
*/
		
			//Attempt to insert student_id into student_session
				include $_SERVER['DOCUMENT_ROOT'] . '/includes/mfdb.inc.php';	
				if (!mysqli_query($link, $sql))
					{
						$error = 'Error adding student_id to student_session.';
						include 'error.html.php';
						exit();
					}
			//Get last session_id from student_session table
				$sql = "select max(session_id) from student_session where student_id = '" . $_SESSION['student_id'] . "'";
				$_SESSION['session_id'] = get_scalar($sql);
				
		
		include 'equation.html.php';
		exit();
			

/*----New Code to Add--------------------------
		Put checkbox on config page that only displays
		for an administrator. Label it "Test Mode" and
		have it display results from the Web Visitor,
		while other users do not see his results.
	
		For testing, set session variable to 1, then
		have first section of code display info if
		session var is 1 and set code to 2. Then next
		session could display if it is 2 and set to 3
		and so on.
				
------------------------------------------------*/
?>