<?php
/*Controller Code for Displaying student administration in the Math Facts Tool*/

/*
	Use gto(Subheading, IntVariable, TestVariable) for Testing
	Call with the Get Method - ?debug=IntVariable
	Use Subheading to identify contents of TestVariable
*/
	session_start();
	
	include_once $_SERVER['DOCUMENT_ROOT'] . '/includes/magicquotes.inc.php';
	include_once $_SERVER['DOCUMENT_ROOT'] . '/includes/helpers.inc.php';
	include_once $_SERVER['DOCUMENT_ROOT'] . '/includes/access.inc.php';
	
if (!userisloggedin())
{
	$_SESSION['loginerror'] = "You must log in as a teacher or administrator to view the students page.";
  header('Location: ../');
  exit(); 
}

if (!userhasrole('Administrator') and !userhasrole('Teacher'))
{
	$_SESSION['loginerror'] = "You do not have permission to view the selected page.";
  header('Location: ../');
  exit();
}

//Get value of student where clause
$whcls = $_SESSION['whcls'];

//**************Add Student********************
	include $_SERVER['DOCUMENT_ROOT'] . '/includes/mfdb.inc.php';
	if (isset($_POST['action']) and $_POST['action']=='add_student')
	{
		//gto('Started','Criteria met');
		$teacher_id = $_SESSION['student_id'];
		$first_name = mysqli_real_escape_string($link, $_POST['first_name']);
		$last_name = mysqli_real_escape_string($link, $_POST['last_name']);
		$email = mysqli_real_escape_string($link, $_POST['email']);
		$password = md5($_POST['password'] . 'rmtmf');
		$password = mysqli_real_escape_string($link, $password);
		
		$sql = "insert into members set 
						teacher_id='$teacher_id',
						type='Student', 
						first_name='$first_name',
						last_name='$last_name', 
						email='$email', 
						password='$password'";
		if(!mysqli_query($link,$sql))
		{
			$error = 'Error inserting new student record (student/index.php).';
			$error .= 'Text of query is:<br>' . $sql;
			include $_SERVER['DOCUMENT_ROOT'] . '/includes/error.html.php';
			exit();
		}
		
	//Add role for student
		$st_id = get_scalar("select id from members where email = '$email'");
		$sql = "insert into member_role set
						member_id = '$st_id',
						role_id = 'Student'";
		if(!mysqli_query($link,$sql))
		{
			$error = 'Error inserting role for new student (student/index.php).';
			$error .= 'Text of query is:<br>' . $sql;
			include $_SERVER['DOCUMENT_ROOT'] . '/includes/error.html.php';
			exit();
		}
	//Update session variable for where clause
		$whcls = '';
		$sql = 'select id from members where teacher_id = ' . $_SESSION['student_id'];
		$result = mysqli_query($link, $sql);
		
		if(!$result)
			{
				$error = 'Error obtaining student data for teacher (student/index - 77).'
					. "<br>Text of query is:<br>".$sql;
				include $_SERVER['DOCUMENT_ROOT'] . '/includes/error.html.php';
				exit();
			}
			
			while($row = mysqli_fetch_array($result))
			{
				$whcls .= $row['id'] . ',';
			}
			$whcls = substr($whcls,0,-1);	//Trim ending comma
			if(!$whcls)
				$whcls = 'NA';
			else
				$whcls = ' in (' . $whcls . ')';
			unset($_SESSION['whcls']);
			$_SESSION['whcls'] = $whcls;						
	
	}		//***************End of Add Student**************

//**************Unlearned Fact Family Report********************
	include $_SERVER['DOCUMENT_ROOT'] . '/includes/mfdb.inc.php';
	if ($_GET['report']=='uff')
	{
		
		if (isset($_GET['uff_st_id']))		//Name in report was clicked
		{
			//gto('StringGet(uff_st_id) is:',$_GET['uff_st_id']);
			$criteria = $_GET['uff_st_id'];
			
			$sql = "SELECT * from unlearned_ff_vw where st_id = " . $criteria;
		}
		else
		{
			$sql = "SELECT * from unlearned_ff_vw \n"
	    //. "where st_id " . $whcls;
	      . "where st_id in (3,4,5)";
	  }
	  	$sql .= " order by st_id asc, operation asc, avg desc";
    
    include $_SERVER['DOCUMENT_ROOT'] . '/includes/mfdb.inc.php';
    $result = mysqli_query($link, $sql);
    
    if(!$result)
    {
			$error = 'Error obtaining data from unlearned_ff_vw (student/index.php).';
			$error .= 'Text of query is:<br>' . $sql;
			include $_SERVER['DOCUMENT_ROOT'] . '/includes/error.html.php';
			exit();
		}
    
    while ($row = mysqli_fetch_array($result))
    	{
    		$uff[] = array(
    			'student' => $row['student'],
    			'st_id' => $row['st_id'],
    			'operation' => $row['operation'],
    			'ff_id' => $row['ff_id'],
    			'family' => $row['family'],
    			'num' => $row['num'],
    			'avg' => $row['avg'],
    			'iters' => $row['iters'],
    			'mintime' => $row['mintime']
    			);
    	}
    	$process_type="uff";
	    include 'students.html.php';
	    exit();
	}
		
//***********		End of Unlearned Fact Family Report	********************

//**************Fact Family Details********************
	include $_SERVER['DOCUMENT_ROOT'] . '/includes/mfdb.inc.php';
	if ($_GET['report']=='ff_details' and isset($_GET['uff_st_id']) 
			and isset($_GET['uff_operation']) and isset($_GET['uff_ff_id']))
	{
		$uff_st_id = $_GET['uff_st_id'];
		$uff_operation = $_GET['uff_operation'];
		$uff_ff_id = $_GET['uff_ff_id'];
		
		$sql = "SELECT * from student_results where \n"
				 . "student_id = '$uff_st_id' and \n"
				 . "fact_family_id = '$uff_ff_id' and \n"
				 . "operation = '$uff_operation' \n"
				 . "order by elapsed_time+0 desc";
		
		$result = mysqli_query($link, $sql);
    
    if(!$result)
    {
			$error = 'Error obtaining data from student_results (student/index.php).';
			$error .= 'Text of query is:<br>' . $sql;
			include $_SERVER['DOCUMENT_ROOT'] . '/includes/error.html.php';
			exit();
		}
    
    while ($row = mysqli_fetch_array($result))
    	{
    		$uff_st_results[] = array(
    			'date' => date('M j Y g:i a', strtotime($row['date'])),
    			//'date' => $row['date'],
    			'session_id' => $row['session_id'],
    			'st_id' => $row['student_id'],
    			'ff_id' => $row['fact_family_id'],
    			'operation' => $row['operation'],
    			'elapsed_time' => $row['elapsed_time']
    			);
    		}
    //Get data for title
    	$sql = "SELECT distinct fact_family FROM student_results_vw \n"
    			 . "WHERE ff_id = '$uff_ff_id'";
    	$ff_name = get_scalar($sql);
    	$sql = "SELECT first_name from members \n"
    			 . "WHERE id = '$uff_st_id'";
    	$st_name = get_scalar($sql);
    	
    	$process_type="uff_st_results";
	    include 'students.html.php';
	    exit();
	}

//**************End of Fact Family Details********************
	
//**************Configure student*****************
	if (isset($_POST['action']) and $_POST['action']=='Edit')
	{
	//Get student id
		$_SESSION['edit_id'] = mysqli_real_escape_string($link, $_POST['st_id']);
		$st_id = $_SESSION['edit_id'];
	//Get student name
		$student_name = '';
		$sql = "select concat(first_name,\" \",last_name)
						from members where id = '$st_id'";
		$student_name = get_scalar($sql);
		$student_fname = get_scalar("select first_name from members where id = '$st_id'");
	
	//Determine how many families are configured for this student
		$configs = get_scalar("select count(1) from student_config
								where student_id = '$st_id'");
	
		if ($configs > 0)
		{
		$sql = "SELECT \n"
    . "concat(b.first_name,\" \",b.last_name) as name,\n"
    . "b.id as st_id, \n"
    . "a.operation as operation,\n"
    . "a.min_number as min_number,\n"
    . "a.max_number as max_number,\n"
    . "a.practice_time_limit as time_limit,\n"
    . "a.proficiency_time_limit as time_target, \n"
    . "a.proficiency_iterations as min_times,\n"
    . "a.number_problems as number_problems\n"
    . " FROM student_config as a\n"
    . "inner join members as b on b.id = a.student_id\n"
    . "WHERE student_id = '$st_id'";
    //gto('st_id is',$st_id);
    //gto('Query string is ',$sql);
    
    include $_SERVER['DOCUMENT_ROOT'] . '/includes/mfdb.inc.php';
    $result = mysqli_query($link, $sql);
    
    if(!$result)
    {
			$error = 'Error obtaining student configuration info (student/index.php).';
			$error .= 'Text of query is:<br>' . $sql;
			include $_SERVER['DOCUMENT_ROOT'] . '/includes/error.html.php';
			exit();
		}
    
    while ($row = mysqli_fetch_array($result))
    	{
    		$student_config[] = array(
    			'name' => $row['name'],
    			'st_id' => $row['st_id'],
    			'operation' => $row['operation'],
    			'min_number' => $row['min_number'],
    			'max_number' => $row['max_number'],
    			'time_limit' => $row['time_limit'],
    			'time_target' => $row['time_target'],
    			'min_times' => $row['min_times'],
    			'num_probs' => $row['number_problems']
    			);
    	}
    }		//$configs>0
    	$process_type="edit_student_config";
	    include 'students.html.php';
	    exit();
	}
	
//**************Edit Student Configuration*******************
	if (isset($_POST['st_cfg_edit']))
	{
		include $_SERVER['DOCUMENT_ROOT'] . '/includes/mfdb.inc.php';
		//Set variables from input boxes
		$st_id = $_SESSION['edit_id'];
		$operation = mysqli_real_escape_string($link, $_POST['operation']);
		$min_number = mysqli_real_escape_string($link, $_POST['min']);
		$max_number = mysqli_real_escape_string($link, $_POST['max']);
		$practice_time_limit = mysqli_real_escape_string($link, $_POST['time_limit']);
		$proficiency_time_limit = mysqli_real_escape_string($link, $_POST['time_target']);
		$proficiency_iterations = mysqli_real_escape_string($link, $_POST['min_times']);
		$number_problems = mysqli_real_escape_string($link, $_POST['number_problems']);
		//gto('st_id and operation are',$st_id . ', ' . $operation);
		//gto('min and max numbs are',$min_number . ', ' . $max_number);
		
		//Insure that all boxes have values
		if($st_id =="" || $operation=="" || $min_number=="" || $max_number=="" 
		|| $proficiency_time_limit=="" || $proficiency_iterations=="" || $number_problems=="")
		{
			$errmsg = 'You must insert values into all fields when editing a student configuration.';
	    include 'students.html.php';
	    exit();
		}
	
	//Insert new record
		if ($_POST['st_cfg_edit']=='Insert')
		{
			$sql = "insert into student_config set
				student_id = '$st_id',
				operation = '$operation',
				min_number = '$min_number',
				max_number = '$max_number',
				practice_time_limit = '$practice_time_limit',
				proficiency_time_limit = '$proficiency_time_limit',
				proficiency_iterations = '$proficiency_iterations',
				number_problems = '$number_problems'";
		//gto('Insert sql is:',$sql);	
		if(!mysqli_query($link,$sql))
		{
			$error = 'Error inserting new configuration setting (student/index.php).';
			$error .= 'Text of query is:<br>' . $sql;
			include $_SERVER['DOCUMENT_ROOT'] . '/includes/error.html.php';
			exit();
		}
			header('Location: .');
			exit();
		}
		
	//Update existing record
		if ($_POST['st_cfg_edit']=='Update')
		{
			$sql = "update student_config set
				min_number = '$min_number',
				max_number = '$max_number',
				practice_time_limit = '$practice_time_limit',
				proficiency_time_limit = '$proficiency_time_limit',
				proficiency_iterations = '$proficiency_iterations',
				number_problems = '$number_problems' 
				where
				student_id = '$st_id' and
				operation = '$operation'";
		//gto('Update sql is:',$sql);	
		if(!mysqli_query($link,$sql))
		{
			$error = 'Error updating configuration setting (student/index.php).';
			$error .= 'Text of query is:<br>' . $sql;
			include $_SERVER['DOCUMENT_ROOT'] . '/includes/error.html.php';
			exit();
		}
			header('Location: .');
			exit();
		}
		
	//Delete
		if ($_POST['st_cfg_edit']=='Delete')
		{
			//gto('Delete operation begins','Testing');
			$sql = "delete from student_config 
				where
				student_id = '$st_id' and
				operation = '$operation'";
		//gto('Update sql is:',$sql);	
		if(!mysqli_query($link,$sql))
		{
			$error = 'Error removing configuration setting (student/index.php).';
			$error .= 'Text of query is:<br>' . $sql;
			include $_SERVER['DOCUMENT_ROOT'] . '/includes/error.html.php';
			exit();
		}
			header('Location: ');
			exit();
		}
	}
	
//**************End of Edit Student Configuration*******************	
	
	
//Setup variables to add student
	if (isset($_GET['add_student']))
	{
		$teacher_id = $_SESSION['student_id'];
		include 'students.html.php';
    exit();
	}
	

//Get data for configuring students
	if (isset($_GET['configure_student']))
	{
    $sql = "select \n"
         . "id as st_id, \n"
         . "first_name \n"
         . "from members \n"
         . "where id " . $whcls;
         
    include $_SERVER['DOCUMENT_ROOT'] . '/includes/mfdb.inc.php';
    $result = mysqli_query($link, $sql);
    
    if(!$result)
    {
			$error = 'Error obtaining student configuration info (student/index.php).';
			$error .= 'Text of query is:<br>' . $sql;
			include $_SERVER['DOCUMENT_ROOT'] . '/includes/error.html.php';
			exit();
		}
    
    while ($row = mysqli_fetch_array($result))
    	{
    		$config[] = array(
    			'st_id' => $row['st_id'],
    			'first_name' => $row['first_name']
    			);
    			//gto('sql is',$sql);
    	}
    	$process_type="setup_student_config";
    	include 'students.html.php';
    	exit();
	}


include $_SERVER['DOCUMENT_ROOT'] . '/includes/mfdb.inc.php';
//If session_id is selected, show results from session
if (isset($_GET['sess_id']))
{
	$sql = "select * from student_results_vw where session_id = '"
	      . $_GET['sess_id'] . "' order by time+0 desc";
	$result = mysqli_query($link, $sql);
	
	if(!$result)
	{
		$error = 'Error obtaining session info from student_results_vw';
		include $_SERVER['DOCUMENT_ROOT'] . '/includes/error.html.php';
		exit();
	}
	
	while ($row = mysqli_fetch_array($result))
				{
					$session[] = array(
						'session_id' => $row['session_id'],
						'student_id' => $row['student_id'],
						'Date' => strftime('%A %b %e, %Y',$row['date']),
						'Name' => $row['name'],
						'ff' => $row['fact_family'],
						'operation' => $row['operation'],
						'time' => $row['time']
						);
				}			
	//gto('Get it all','All',5);
	$process_type="display_session";
	include 'students.html.php';
	exit();
		
}
			
//Check to see if student ID was selected.
	//Output summary information
	{
		if (isset($_GET['st_id']))
		{
			$sql = "Select * from student_summary_vw where st_id = '"
			     . $_GET['st_id'] . "'";
			unset($_GET['st_id']);
		}
		elseif ($whcls!="NA")	//Use basic select statement
		{
			$sql = "SELECT * from student_summary_vw where st_id $whcls limit 500";
		}
		else
		{
			include 'students.html.php';
			exit();
		}
		//Fill array with student's results	
			$result = mysqli_query($link, $sql);
				if(!$result)
				{
					$error = 'Error obtaining basic summary of student results.<br>';
					$error .= 'Query text was:<br>'.$sql;
					include $_SERVER['DOCUMENT_ROOT'] . '/includes/error.html.php';
					exit();
				}
				
				while ($row = mysqli_fetch_array($result))
				{
					$summary[] = array(
						'SessID' => $row['sess_id'],
						'St_ID' => $row['st_id'],
						'Date' => date('M j g:i a', strtotime($row['date'])),
						'Name' => $row['name'],
						'Type' => $row['type'],
						'Problems' => $row['problems'],
						'Range' => $row['range'],
						'Correct' => $row['right'],
						'Wrong' => $row['wrong'],
						'Avg' => $row['avg_time'],
						'< 5 secs' => $row['<_5_secs'],
						'< 3 secs' => $row['<_3_secs']
						);
				}	
			
			include 'students.html.php';
			exit();
		}	
		
		

?>